/*
	$Id: Member.java 324 2007-05-26 18:39:12Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ¤Τޤ϶ΤΥФǤ
*/
public class Member {

    /** 롼 */
    private Group group;

    /** ɥȤ˵ܤ뤳ΥФη */
    private String descType;

    /** type° */
    private String type;

    /** name° */
    private String name;

    /** °빽¤Τޤ϶Τ̾ */
    private Strings parentName;

    /** descǤ */
    private Description desc;

    /**
       Фޤ

       @param g 饹
       @param parentName °빽¤Τޤ϶Τ̾
       @param type type°
       @param elem member
    */
    public Member(final Group g, final Strings parentName, final String type,
		  final Element elem) {
	group = g;
	this.parentName = parentName;
	this.type = type;

	IDManager id = IDManager.getInstance();
	name = id.getIDAttribute(elem, "name");

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
	setDescType(type);
    }

    /**
       Ф̾ޤ

       @return Ф̾
    */
    public String getName() {
	return name;
    }

    /**
       Фηޤ

       @return Фη
    */
    protected String getType() {
	return type;
    }

    /**
       Ф°빽¤Τޤ϶Τ̾ޤ

       @return Фη
    */
    protected Strings getParentName() {
	return parentName;
    }

    /**
       Фޤ

       @return Ф
    */
    protected Description getDescription() {
	return desc;
    }

    /**
       ɥȤ˵ܤ뤳ΥФηꤷޤ

       @param descType ɥȤ˵ܤ뤳ΥФη
    */
    protected void setDescType(final String descType) {
	this.descType = descType;
    }

    /**
       ɥȤ˵ܤ뤳ΥФηޤ

       @return ɥȤ˵ܤ뤳ΥФη
    */
    public String getDescType() {
	return descType;
    }

    /**
       ɤϤޤ

       @param wr 饤
       @param indent ǥȤʸ
    */
    public void printCode(final PrintWriter wr, final String indent) {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    wr.println(indent
		       + type.substring(0, k)
		       + name
		       + type.substring(k + 1)
		       + ";");
	} else {
	    wr.println(indent + type + " " + name + ";");
	}
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	String descType = getDescType();
	int k = CommentedString.indexOf(descType, '#');
	if (k != -1) {
	    descType = descType.substring(0, k)	+ descType.substring(k + 1);
	}
	wr.println(""
+ "<tr>\n"
+ "  <td align=\"right\" valign=\"top\" width=\"1%\">\n"
+ "    <font size=\"-1\">&nbsp;" + group.getHTML(descType) + "</font>\n"
+ "  </td>\n"
+ "  <td valign=\"top\"><a href=\"#" + parentName + "." + name + "\">"
+ "<b>" + name + "</b></a><br>\n"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	IDManager m = IDManager.getInstance();
	String descType = getDescType();
	String leftType, rightType;

	int k = CommentedString.indexOf(descType, '#');
	if (k == -1) {
	    leftType = descType;
	    rightType = "";
	} else {
	    leftType = descType.substring(0, k);
	    rightType = descType.substring(k + 1);
	}
	wr.println(""
+ "<p><a name=\"" + parentName + "." + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name + "</b></font></p>\n"
+ "<p>"
+ group.getHTML(leftType)
+ " <b>" + name + "</b>"
+ group.getHTML(rightType)
+ "</p>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n"
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	String texName = Tex.safe(name);
	String leftType, rightType;

	int k = CommentedString.indexOf(type, '#');
	if (k == -1) {
	    leftType = type;
	    rightType = "";
	} else {
	    leftType = type.substring(0, k);
	    rightType = type.substring(k + 1);
	}
	leftType = group.getTEX(leftType);
	rightType = group.getTEX(rightType);

	wr.println("");
	wr.println("\\Smember{" + texName + "}");
	wr.println("\\nopagebreak");
	wr.print("\\begin{Sindentation}{\\Sindentlength}{0pt}\n");

	// Syntax
	wr.println("\\begin{Ssyntax}%");
	wr.println(leftType + " {\\bfseries " + texName + "}" + rightType);
	wr.println("\\end{Ssyntax}");

	// Description
	wr.println("");
	wr.print(desc.getTexText());

	wr.print("\\end{Sindentation}");
    }
}
