/*
	$Id: NodeException.java 305 2007-03-16 18:35:59Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

import org.w3c.dom.Node;
import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import java.util.Stack;

/**
   DTDɽʤDOMΡɤ㳰Ǥ
*/
public class NodeException extends RuntimeException {

    /** Ȥʤä° */
    private Attr attr;

    /** Ȥʤä */
    private Element elem;

    /**
       °㳰ޤ

       @param attr Ȥʤä°
       @param s å
    */
    public NodeException(final Attr attr, final String s) {
	super(s);
	this.attr = attr;
	this.elem = attr.getOwnerElement();
    }

    /**
       Ǥ㳰ޤ

       @param elem Ȥʤä
       @param s å
    */
    public NodeException(final Element elem, final String s) {
	super(s);
	this.attr = null;
	this.elem = elem;
    }

    /**
       㳰ȯΥҥȤޤ

       @return 㳰ȯΥҥ
    */
    public String getLocation() {
	Stack<Node> v = new Stack<Node>();
	for (Node n = elem;
	     n != null && n.getNodeType() != Node.DOCUMENT_NODE;
	     n = n.getParentNode()) {
     	    v.push(n);
	}
	String t = "";
	String indent = "";
	String attrName = (attr == null) ? "" : attr.getName();
	String elemName = elem.getNodeName();
	int elemOffset = 0;
	int attrOffset = 0;
	while (!v.empty()) {
	    Element e = (Element) v.pop();
	    String s = indent + "<";
	    if (elemName.equals(e.getNodeName())) {
		elemOffset = s.length();
	    }
	    s += e.getNodeName();
	    NamedNodeMap map = e.getAttributes();
	    int len = map.getLength();
	    for (int k = 0; k < len; ++k) {
		Attr a = (Attr) map.item(k);
		if (!a.getSpecified()) {
		    continue;
		}
		s += " ";
		if (attrName.equals(a.getName())) {
		    attrOffset = s.length();
		}
		String value = a.getValue()
		    .replaceAll("&", "&amp;")
		    .replaceAll("'", "&apos;");
		s += a.getName() + "='" + value + "'";
	    }
	    s += ">";
	    t += s + "\n";
	    indent += "  ";
	}
	int k, m, n;
	if (attr == null) {
	    m = elemOffset;
	    n = m + elemName.length();
	} else {
	    m = attrOffset;
	    n = m + attrName.length();
	}
	byte[] skip = new byte[n];
	for (k = 0; k < m; ++k) {
	    skip[k] = ' ';
	}
	for (; k < n; ++k) {
	    skip[k] = '~';
	}
	return t + new String(skip) + "\n";
    }
}
